﻿-- Author      : Nogarder
-- Create Date : 2012/12/11 11:04:06
local table_getn=table.getn
local table_insert=table.insert
local pairs=pairs
local next=next
local UnitGUID=UnitGUID
local UnitExists=UnitExists
local string_find=string.find
local string_sub=string.sub
local tonumber=tonumber
local NPA_GetTime=NPA.GetTime
--
local NPA_EventHandler_FireEvent=NPA.EventHandler.FireEvent
--
local UpdateProfile=function(framedata,prioritylist,count)
	for i=1,count do
		local profile=NPA_Setting.NamePlate[prioritylist[i]]
		if(profile)then
			if(profile~=framedata.Profile)then
				--only fire event when different
				framedata.Profile=profile
				NPA_EventHandler_FireEvent(1,"NamePlate_ProfileChange",framedata,profile)
			end
			return
		end
	end
	--when nothing matches, dont do anything, yet
end
--
local PriorityLists={}
--create condition list for every framedata
NPA.EventHandler.RegisterEvent(1,"NamePlate_DefaultMain_OnHook","NamePlate_ProfileManager",function(framedata)
	PriorityLists[framedata]={}
end)
--
NPA.EventHandler.RegisterEvent(6,"NamePlate_ConditionUpdated","NamePlate_ProfileManager",function()
	local NPA_EventHandler_RegisterEvent=NPA.EventHandler.RegisterEvent
	--build condition check list
	for _,data in pairs(PriorityLists)do
		data={}
	end
	--
	local TargetCondition={}
	local NameCondition={}
	local PartNameCondition={}
	local UnitIDCondition={}
	local SummonedCondition={}
	local PlayerCondition={}
	local NonPlayerCondition={}
	local WithAuraCondition={}
	local WithoutAuraCondition={}
	local HealthMoreCondition={}
	local HealthLessCondition={}
	local WithCoolDownCondition={}
	local WithoutCoolDownCondition={}
	--
	local settings=NPA_Setting.NamePlateCondition
	--clear old elements
	NPA_EventHandler_RegisterEvent(1,"NamePlate_DefaultMain_OnShow","NamePlate_ProfileManager",nil)
	NPA_EventHandler_RegisterEvent(1,"NamePlate_ModuleMain_OnUpdate","NamePlate_ProfileManager",nil)
	NPA_EventHandler_RegisterEvent(8,"Quest_Updated","NamePlate_ProfileManager",nil)
	NPA_EventHandler_RegisterEvent(8,"Name_Updated","NamePlate_ProfileManager",nil)
	NPA_EventHandler_RegisterEvent(8,"GUID_Attached","NamePlate_ProfileManager",nil)
	NPA_EventHandler_RegisterEvent(8,"Summoned_Updated","NamePlate_ProfileManager",nil)
	NPA_EventHandler_RegisterEvent(8,"Type_Updated","NamePlate_ProfileManager",nil)
	--
	local count=table_getn(settings)
	--add event elements
 	for i=1,count do
		local setting=settings[i]
		if(setting.ConditionType=="Any")then
			--any would always be using
			--using any when shown
			NPA_EventHandler_RegisterEvent(1,"NamePlate_DefaultMain_OnShow","NamePlate_ProfileManager",function(framedata)
					local prioritylist=PriorityLists[framedata]
					prioritylist[i]=setting.Profile
					--
					UpdateProfile(framedata,prioritylist,count)
				end)
		elseif(setting.ConditionType=="Quest")then
			NPA_EventHandler_RegisterEvent(8,"Quest_Updated","NamePlate_ProfileManager",function(framedata,data)
				local prioritylist=PriorityLists[framedata]
				--
				if(data==true)then
					--data could be isloopback
					return
				elseif(data)then
					prioritylist[i]=setting.Profile
				else
					prioritylist[i]=nil
				end
				UpdateProfile(framedata,prioritylist,count)
			end)
		elseif(setting.ConditionType=="Name")then
			table_insert(NameCondition,i)
		elseif(setting.ConditionType=="PartName")then
			table_insert(PartNameCondition,i)
		elseif(setting.ConditionType=="UnitID")then
			table_insert(UnitIDCondition,i)
		elseif(setting.ConditionType=="Summoned")then
			table_insert(SummonedCondition,i)
		elseif(setting.ConditionType=="Player")then
			table_insert(PlayerCondition,i)
		elseif(setting.ConditionType=="NonPlayer")then
			table_insert(NonPlayerCondition,i)
		elseif(setting.ConditionType=="Target")then
			table_insert(TargetCondition,i)
		elseif(setting.ConditionType=="WithAura")then
			table_insert(WithAuraCondition,i)
		elseif(setting.ConditionType=="WithoutAura")then
			table_insert(WithoutAuraCondition,i)
		elseif(setting.ConditionType=="HealthMore")then
			table_insert(HealthMoreCondition,i)
		elseif(setting.ConditionType=="HealthLess")then
			table_insert(HealthLessCondition,i)
		elseif(setting.ConditionType=="WithCoolDownCondition")then
			table_insert(WithCoolDown,i)
		elseif(setting.ConditionType=="WithoutCoolDownCondition")then
			table_insert(WithoutCoolDown,i)
		end
	end
	--target
	if(next(TargetCondition))then
		NPA_EventHandler_RegisterEvent(1,"NamePlate_ModuleMain_OnUpdate","NamePlate_ProfileManager",function(framedata)
			local guid=framedata.GUID
			if(not guid)then
				return
			end
			--
			local prioritylist=PriorityLists[framedata]
			--
			local update
			for i=1,table_getn(TargetCondition)do
				local index=TargetCondition[i]
				--check priority
				local setting=settings[index]
				local check=(UnitExists(setting.Arg) and guid==UnitGUID(setting.Arg))
				if(prioritylist[index]==nil and check)then
					prioritylist[index]=setting.Profile
					update=true
				elseif(prioritylist[index]~=nil and not check)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateProfile(framedata,prioritylist,count)
			end
		end)
	end
	--name
	if(next(NameCondition) or next(PartNameCondition))then
		NPA_EventHandler_RegisterEvent(8,"Name_Updated","NamePlate_ProfileManager",function(framedata,isloopback)
			local name=framedata.UnitData.Name
			if(isloopback or not name)then
				--in case is loopback or no name yet
				return
			end
			--
			local prioritylist=PriorityLists[framedata]
			--
			local update
			--name check
			for i=1,table_getn(NameCondition)do
				local index=NameCondition[i]
				--check priority
				local setting=settings[index]
				if(prioritylist[index]==nil and name==setting.Arg)then
					prioritylist[index]=setting.Profile
					update=true
				elseif(prioritylist[index]~=nil and name~=setting.Arg)then
					prioritylist[index]=nil
					update=true
				end
			end
			--part name check
			for i=1,table_getn(PartNameCondition)do
				local index=PartNameCondition[i]
				--check priority
				local setting=settings[index]
				local found=string_find(name,setting.Arg)
				if(prioritylist[index]==nil and found)then
					prioritylist[index]=setting.Profile
					update=true
				elseif(prioritylist[index]~=nil and not found)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateProfile(framedata,prioritylist,count)
			end
		end)
	end
	--unitid
	if(next(UnitIDCondition))then
		NPA_EventHandler_RegisterEvent(8,"GUID_Attached","NamePlate_ProfileManager",function(framedata,isloopback)
			if(isloopback)then
				return
			end
			--
			local prioritylist=PriorityLists[framedata]
			--this will get an unit id for npc
			local unitid=tonumber(string_sub(framedata.UnitData.GUID,7,10),16)
			local update
			--name check
			for i=1,table_getn(UnitIDCondition)do
				local index=UnitIDCondition[i]
				--check priority
				local setting=settings[index]
				if(prioritylist[index]==nil and unitid==tonumber(setting.Arg))then
					prioritylist[index]=setting.Profile
					update=true
				elseif(prioritylist[index]~=nil and unitid~=tonumber(setting.Arg))then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateProfile(framedata,prioritylist,count)
			end
		end)
	end
	--summoned
	if(next(SummonedCondition))then
		NPA_EventHandler_RegisterEvent(8,"Summoned_Updated","NamePlate_ProfileManager",function(framedata,isloopback)
			if(isloopback)then
				return
			end
			--
			local prioritylist=PriorityLists[framedata]
			--filter out sometime the sourceunitdata is not avaliable
			if(not framedata.UnitData.SummonedByUnitData)then
				return
			end
			--
			local update
			--check summoned
			local sourcefaction=framedata.UnitData.SummonedByUnitData.Faction
			for i=1,table_getn(SummonedCondition)do
				local index=SummonedCondition[i]
				--check priority
				local setting=settings[index]
				--faction, 1=friendly,2=neutral,3=hostile
				if(prioritylist[index]==nil and tonumber(setting.Arg)==sourcefaction)then
					prioritylist[index]=setting.Profile
					update=true
				elseif(prioritylist[index]~=nil and tonumber(setting.Arg)~=sourcefaction)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateProfile(framedata,prioritylist,count)
			end
		end)
	end
	--player
	if(next(PlayerCondition) or next(NonPlayerCondition))then
		NPA_EventHandler_RegisterEvent(8,"Type_Updated","NamePlate_ProfileManager",function(framedata,isloopback)
			if(isloopback)then
				return
			end
			--
			local prioritylist=PriorityLists[framedata]
			--filter out sometime the sourceunitdata is not avaliable
			local update
			--check summoned
			local faction=framedata.UnitData.Faction
			local atype=framedata.UnitData.Type
			--data.Type= 1=player, 2=totem, 3=creature, 4=vendor, nil=unknow
			if(atype==1)then --1=player
				for i=1,table_getn(PlayerCondition)do
					local index=PlayerCondition[i]
					--check priority
					local setting=settings[index]
					--faction, 1=friendly,2=neutral,3=hostile
					if(prioritylist[index]==nil and tonumber(setting.Arg)==faction)then
						prioritylist[index]=setting.Profile
						update=true
					elseif(prioritylist[index]~=nil and tonumber(setting.Arg)~=faction)then
						prioritylist[index]=nil
						update=true
					end
				end
			elseif(atype==nil)then --nil is NPC
				for i=1,table_getn(NonPlayerCondition)do
					local index=NonPlayerCondition[i]
					--check priority
					local setting=settings[index]
					--faction, 1=friendly,2=neutral,3=hostile
					if(prioritylist[index]==nil and tonumber(setting.Arg)==faction)then
						prioritylist[index]=setting.Profile
						update=true
					elseif(prioritylist[index]~=nil and tonumber(setting.Arg)~=faction)then
						prioritylist[index]=nil
						update=true
					end
				end
			end
			--
			if(update)then
				UpdateProfile(framedata,prioritylist,count)
			end
		end)
	end
	--
	--aura
	if(next(WithAuraCondition) or next(WithoutAuraCondition))then
		NPA_EventHandler_RegisterEvent(8,"Aura_Updated","NamePlate_ProfileManager",function(framedata,isloopback)
			if(isloopback or not framedata.UnitData.Aura)then
				return
			end
			--
			local nTime=NPA_GetTime()
			local prioritylist=PriorityLists[framedata]
			--
			local update
			local auralist=framedata.UnitData.Aura
			--check with list
			for i=1,table_getn(WithAuraCondition)do
				local index=WithAuraCondition[i]
				local setting=settings[index]
				local spellid=tonumber(setting.Arg)
				local checked
				for i=1,table_getn(auralist)do
				--check with list
					if(auralist[i].SpellId==spellid and auralist[i].ExpirationTime>nTime)then
						checked=true
						break
					end
				end
				if(checked==true and prioritylist[index]==nil)then
					prioritylist[index]=setting.Profile
					update=true
				elseif(checked==nil and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--check without list , just the revers version of with
			for i=1,table_getn(WithoutAuraCondition)do
				local index=WithoutAuraCondition[i]
				local setting=settings[index]
				local checked
				for i=1,table_getn(auralist)do
				--check with list
					if(auralist[i].SpellId==tonumber(setting.Arg) and auralist[i].ExpirationTime>nTime)then
						checked=true
						break
					end
				end
				if(checked==nil and prioritylist[index]==nil)then
					prioritylist[index]=setting.Profile
					update=true
				elseif(checked==true and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateProfile(framedata,prioritylist,count)
			end
		end)
	end
	--health
	if(next(HealthMoreCondition) or next(HealthLessCondition))then
		NPA_EventHandler_RegisterEvent(8,"Health_Updated","NamePlate_ProfileManager",function(framedata,isloopback)
			local unitdata=framedata.UnitData
			if(isloopback or (not unitdata.HealthMax) or (not unitdata.Health))then
				return
			end
			--
			local healthpercent=unitdata.Health/unitdata.HealthMax
			--check "more" condition
			for i=1,table_getn(HealthMoreCondition)do
				local index=HealthMoreCondition[i]
				local setting=settings[index]
				local checked
				--check with list
				if(healthpercent>=tonumber(setting.Arg)/100)then
					checked=true
				end
				if(checked==true and prioritylist[index]==nil)then
					prioritylist[index]=setting.Profile
					update=true
				elseif(checked==nil and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--check "less" condition
			for i=1,table_getn(HealthLessCondition)do
				local index=HealthLessCondition[i]
				local setting=settings[index]
				local checked
				--check with list
				if(healthpercent<=tonumber(setting.Arg)/100)then
					checked=true
				end
				if(checked==true and prioritylist[index]==nil)then
					prioritylist[index]=setting.Profile
					update=true
				elseif(checked==nil and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateProfile(framedata,prioritylist,count)
			end
		end)
	end
	--cooldown
	if(next(WithCoolDownCondition) or next(WithoutCoolDownCondition))then
		NPA_EventHandler_RegisterEvent(8,"CoolDown_Updated","NamePlate_ProfileManager",function(framedata,isloopback)
			if(isloopback or (not framedata.UnitData.CoolDown))then
				return
			end
			--
			local nTime=NPA_GetTime()
			--
			local update
			local auralist=framedata.UnitData.CoolDown
			--check with list
			for i=1,table_getn(WithCoolDownCondition)do
				local index=WithAuraCondition[i]
				local setting=settings[index]
				local checked
				local spellid=tonumber(setting.Arg)
				for i=1,table_getn(auralist)do
					--check with list
					if(auralist[i].SpellId==spellid and auralist[i].ExpirationTime>nTime)then
						checked=true
						break
					end
				end
				if(checked==true and prioritylist[index]==nil)then
					prioritylist[index]=setting.Profile
					update=true
				elseif(checked==nil and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--check without list , just the revers version of with
			for i=1,table_getn(WithoutCoolDownCondition)do
				local index=WithoutAuraCondition[i]
				local setting=settings[index]
				local spellid=tonumber(setting.Arg)
				local checked
				for i=1,table_getn(auralist)do
					--check with list
					if(auralist[i].SpellId==spellid and auralist[i].ExpirationTime>nTime)then
						checked=true
						break
					end
				end
				if(checked==nil and prioritylist[index]==nil)then
					prioritylist[index]=setting.Profile
					update=true
				elseif(checked==true and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateProfile(framedata,prioritylist,count)
			end
		end)
	end
	--update all
	--no argument
	for framedata,_ in pairs(PriorityLists)do
		--refire all unitdata updated event
		NPA_EventHandler_FireEvent(8,"Any",framedata)
		--also fire a onshow for any
		NPA_EventHandler_FireEvent(1,"NamePlate_DefaultMain_OnShow",framedata)
	end
end)
